CREATE OR REPLACE FUNCTION core.create_address (json, OUT result json) AS
$$
DECLARE
  new_address_uuid uuid;
BEGIN
  INSERT INTO core.address (
    addr1,
    addr2,
    locality,
    subdivision,
    country,
    code,
    type
  )
  SELECT
    p.addr1,
    p.addr2,
    p.locality,
    p.subdivision,
    p.country,
    p.code,
    p.type
  FROM json_to_record($1) AS p (
    addr1       text,
    addr2       text,
    locality    text,
    subdivision text,
    country     text,
    code        text,
    type        smallint
  )
  RETURNING address_uuid INTO new_address_uuid;

  UPDATE core.party
  SET address_uuid = new_address_uuid
  WHERE party_uuid = ($1->>'party_uuid')::uuid;
  
  result = core.address(new_address_uuid);
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
