CREATE TYPE core.party_short AS (
  party_uuid   uuid,
  kind         core.party_kind_t,
  name         text,
  email        text,
  uri          text,
  trading_name text
);

CREATE OR REPLACE FUNCTION core.list_parties (json)
RETURNS SETOF core.party_short AS
$$
BEGIN
  RETURN QUERY
  SELECT
    p.party_uuid,
    p.kind,
    p.name,
    p.email,
    p.uri,
    o.trading_name
  FROM core.party p
  LEFT JOIN core.search s
    ON s.object_uuid = p.party_uuid
  LEFT JOIN core.organisation o
    ON o.party_uuid = p.party_uuid
  WHERE s.tsv @@ to_tsquery(replace($1->>'search', ' ', ':* & ') || ':*');
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
