CREATE OR REPLACE FUNCTION core.party (json, OUT result core.party) AS
$$
BEGIN
  SELECT INTO result
    p.party_uuid,
    p.kind,
    p.name,
    p.email,
    p.uri,
    p.data,
    p.address_uuid,
    p.billing_address_uuid,
    p.timezone_abbrev,
    p.language_code,
    pr.mobile,
    pr.phone,
    o.trading_name,
    o.url,
    o.industry_code
  FROM core.party p
  LEFT JOIN core.person pr
    ON pr.party_uuid = p.party_uuid
  LEFT JOIN core.organisation o
    ON o.party_uuid = p.party_uuid
  WHERE p.party_uuid = ($1->>'party_uuid')::uuid
    OR p.email = $1->>'email'
    OR p.uri = $1->>'uri';
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
