CREATE OR REPLACE FUNCTION core.subdivisions (json, OUT result json) AS
$$
BEGIN
  IF $1->'country' IS NOT NULL THEN
    WITH subdivisions AS (
      SELECT
        s.code,
        s.pretty
      FROM core.subdivision s
      WHERE s.alpha_2 = $1->>'country'
    )
    SELECT INTO result
      json_strip_nulls(json_agg(s))
    FROM subdivisions s;
  END IF;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;