CREATE OR REPLACE FUNCTION core.update_address (json, OUT result json) AS
$$
BEGIN
  EXECUTE (
    SELECT
      format('UPDATE core.address SET (%s) = (%s) WHERE address_uuid = ''%s''', c.column, c.value, c.address_uuid)
    FROM (
      SELECT
        string_agg(q.column, ', ') AS column,
        string_agg(q.value, ', ') AS value,
        ($1->>'address_uuid')::uuid AS address_uuid
      FROM (
        SELECT
          p.key AS column,
          CASE
            -- check if it's a number
            WHEN p.value ~ '^\d+(.\d+)?$' THEN
              p.value
            WHEN p.value IS NULL THEN
              'NULL'
            ELSE quote_literal(p.value)
          END AS value
        FROM json_each_text($1) p
        WHERE p.key != 'address_uuid'
      ) q
    ) c
  );

  result = core.address(($1->>'address_uuid')::uuid);
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
