\echo 'Installing Core schema...'
\ir schema.sql
\echo 'Done...'
\echo 'Installing Core functions...'
\ir functions/index.sql
\echo 'Done...'

\echo 'Insert core settings...'
INSERT INTO core.setting (name, value) VALUES
  ('default_date_format', 'FMDD Mon YYYY');
  
\echo 'Insert generic core data...'

INSERT INTO core.role (name) VALUES
  ('organisation'),
  ('employer'),
  ('employee'),
  ('primary_contact'),
  ('secondary_contact'),
  ('sales');
  
INSERT INTO core.relationship (name, first_role_id, second_role_id) VALUES
  ('employer employee',
    (SELECT role_id FROM core.role WHERE name = 'employer'),
    (SELECT role_id FROM core.role WHERE name = 'employee')
  ),
  (
    'organisation primary contact',
    (SELECT role_id FROM core.role WHERE name = 'organisation'),
    (SELECT role_id FROM core.role WHERE name = 'primary_contact')
  ),
  (
    'organisation secondary contact',
    (SELECT role_id FROM core.role WHERE name = 'organisation'),
    (SELECT role_id FROM core.role WHERE name = 'secondary_contact')
  ),
  (
    'organisation sales',
    (SELECT role_id FROM core.role WHERE name = 'organisation'),
    (SELECT role_id FROM core.role WHERE name = 'sales')
  );
  
INSERT INTO core.document_status (name) VALUES
  ('draft'),
  ('under review'),
  ('approved');
  
