-- required: core

CREATE EXTENSION IF NOT EXISTS "uuid-ossp";

CREATE SCHEMA fs;

CREATE TABLE fs.node (
  node_uuid   uuid DEFAULT uuid_generate_v4() PRIMARY KEY,
  parent_uuid uuid REFERENCES node (node_uuid) ON DELETE CASCADE,
  owner_uuid  uuid REFERENCES core.party (party_uuid) ON DELETE SET NULL,
  data        jsonb,
  created     timestamptz DEFAULT CURRENT_TIMESTAMP,
  creator     uuid REFERENCES core.party (party_uuid)
);

CREATE TABLE fs.file (
  file_uuid uuid REFERENCES fs.node (node_uuid) ON DELETE CASCADE,
  location  text,  
  PRIMARY KEY (file_uuid)
);
