CREATE OR REPLACE FUNCTION iam.authenticate (json, OUT result json) AS
$$
DECLARE
  identity iam.identity;
BEGIN
  SELECT INTO identity
    i.*
  FROM core.party p
  LEFT JOIN iam.identity i
    ON i.identity_uuid = p.party_uuid
  WHERE p.email = $1->>'email';

  IF identity.hash = crypt($1->>'password', identity.hash) THEN
    SELECT iam.user($1) INTO result;
  END IF;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
