CREATE OR REPLACE FUNCTION iam.create_identity_role (json, OUT result json)
LANGUAGE 'plpgsql' AS $$
BEGIN
  WITH new_identity_role AS (
    INSERT INTO iam.identity_role (
      identity_uuid,
      role_id
    )
    SELECT
      ($1->>'identity_uuid')::uuid,
      r.role_id
    FROM iam.role r
    WHERE r.role_id = ($1->>'role_id')::integer OR
      r.name = $1->>'role_name' OR
      r.name IN (
        SELECT * FROM json_array_elements_text($1->'role_names')
      )
    RETURNING *
  )
  SELECT INTO result
    json_strip_nulls(to_json(n))
  FROM new_identity_role n;
END
$$;
