CREATE OR REPLACE FUNCTION iam.create_identity (json, OUT result json)
LANGUAGE 'plpgsql' AS $$
BEGIN
  WITH new_identity AS (
    INSERT INTO iam.identity (
      identity_uuid,
      hash
    )
    SELECT
      p.party_uuid,
      crypt(p.password, gen_salt('bf'))
    FROM json_to_record($1) AS p (
      party_uuid uuid,
      password   text
    )
    RETURNING *
  )
  SELECT INTO result
    json_strip_nulls(to_json(n))
  FROM new_identity n;
END
$$;
