CREATE OR REPLACE FUNCTION iam.create_user (json, OUT result core.person_v)
LANGUAGE 'plpgsql' AS $$
BEGIN
  WITH new_person AS (
    SELECT
      *
    FROM core.create_person($1)
  ),
  new_identity AS (
    INSERT INTO iam.identity (
      identity_uuid,
      hash
    )
    SELECT
      p.party_uuid,
      crypt($1->>'password', gen_salt('bf'))
    FROM new_person p
  )
  SELECT INTO result
    p.*
  FROM new_person p;
END
$$;
