CREATE OR REPLACE FUNCTION iam.identity (json, OUT result json) AS
$$
BEGIN
  SELECT INTO result
    json_strip_nulls(to_json(r))
  FROM (
    SELECT
      i.identity_uuid,
      p.party_uuid,
      p.name,
      p.email,
      p.uri
    FROM iam.identity i
    LEFT JOIN core.party p
      ON p.party_uuid = i.identity_uuid
    WHERE p.email = $1->>'email'
      OR p.uri = $1->>'uri'
  ) r;
END
$$
LANGUAGE 'plpgsql';
