-- requires: core

CREATE EXTENSION IF NOT EXISTS "pgcrypto";

CREATE SCHEMA iam;

CREATE TABLE iam.identity (
  identity_uuid uuid REFERENCES core.party (party_uuid) ON DELETE CASCADE,
  hash          text NOT NULL,
  created       timestamptz DEFAULT CURRENT_TIMESTAMP,
  created_by    uuid REFERENCES core.party (party_uuid),
  PRIMARY KEY (identity_uuid)
);

CREATE TABLE iam.role (
  role_id    serial PRIMARY KEY,
  name       text UNIQUE,
  created    timestamp DEFAULT CURRENT_TIMESTAMP,
  created_by uuid REFERENCES core.party (party_uuid)
);

CREATE TABLE iam.identity_role (
  identity_uuid uuid REFERENCES iam.identity (identity_uuid) ON DELETE CASCADE,
  role_id       integer REFERENCES iam.role (role_id) ON DELETE CASCADE,
  flags         integer DEFAULT 1,
  created       timestamp DEFAULT CURRENT_TIMESTAMP,
  created_by    uuid REFERENCES core.party (party_uuid)
);
