/*
Create the necessary purchase orders for a sales.order.
*/

CREATE OR REPLACE FUNCTION pcm.create_detail (json, OUT result json) AS
$$
BEGIN
  WITH new_detail AS (
    INSERT INTO pcm.detail (
      purchase_order_uuid,
      product_uuid,
      quantity
    )
    SELECT
      p.*
    FROM json_to_record($1) AS p (
      purchase_order_uuid uuid,
      product_uuid        uuid,
      quantity            numeric(10,3)
    )
    RETURNING *
  )
  SELECT json_strip_nulls(to_json(r)) INTO result
  FROM (
    SELECT
      d.detail_uuid,
      d.purchase_order_uuid,
      d.quantity,
      p.code,
      p.name
    FROM new_detail d
    LEFT JOIN prd.product_v p
      USING (product_uuid)
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
