CREATE OR REPLACE FUNCTION pcm.details (
  json DEFAULT NULL,
  purchase_order_uuid uuid DEFAULT NULL,
  OUT result json
)
LANGUAGE 'plpgsql' AS
$$
BEGIN
  SELECT INTO result
    json_strip_nulls(json_agg(r))
  FROM (
    SELECT
      d.detail_uuid,
      d.quantity,
      p.product_uuid,
      p.name AS product_name,
      p.short_desc,
      p.uom_abbr,
      p.uom_name,
      c.amount AS price
    FROM pcm.detail d
    LEFT JOIN prd.product_v p
      USING (product_uuid)
    LEFT JOIN prd.cost(p.product_uuid) c
      ON c.product_uuid = p.product_uuid
    WHERE d.purchase_order_uuid = ($1->>'purchase_order_uuid')::uuid
      OR d.purchase_order_uuid = $2
  ) r;
END
$$;
