CREATE OR REPLACE FUNCTION pcm.list_purchase_orders (json DEFAULT NULL, OUT result json) AS
$$
BEGIN
  SELECT json_strip_nulls(json_agg(r)) INTO result
  FROM (
    SELECT
      po.purchase_order_uuid,
      po.document_num,
      po.document_status,
      s.name AS seller_name,
      b.name AS buyer_name
    FROM pcm.purchase_order_v po
    LEFT JOIN core.party s
      ON s.party_uuid = po.seller_uuid
    LEFT JOIN core.party b
      ON b.party_uuid = po.buyer_uuid
    ORDER BY po.created DESC
    LIMIT COALESCE(($1->>'limit')::integer, 20)
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
