CREATE OR REPLACE FUNCTION pcm.purchase_order (
  json DEFAULT NULL,
  purchase_order uuid DEFAULT NULL,
  OUT result json
) LANGUAGE 'plpgsql' AS
$$
BEGIN
  SELECT json_strip_nulls(to_json(r)) INTO result
  FROM (
    SELECT
      po.purchase_order_uuid,
      po.document_num,
      po.reference_num,
      po.seller_uuid,
      po.seller_contact_uuid,
      po.buyer_uuid,
      po.buyer_contact_uuid,
      po.document_status,
      po.created,
      s.name AS seller_name,
      b.name AS buyer_name
    FROM pcm.purchase_order_v po
    LEFT JOIN core.party s
      ON s.party_uuid = po.seller_uuid
    LEFT JOIN core.party b
      ON b.party_uuid = po.buyer_uuid
    WHERE po.purchase_order_uuid = ($1->>'purchase_order_uuid')::uuid
      OR po.purchase_order_uuid = $2
  ) r;
END
$$;
