/**
 * Return the cost of an assembly.
 */
CREATE OR REPLACE FUNCTION prd.assembly_cost (uuid, OUT result prd.cost) AS
$$
BEGIN
  SELECT
    $1,
    sum((q.quantity * c.amount)::numeric(10,2)) AS amount
  INTO
    result.product_uuid,
    result.amount
  FROM prd.assembly_quantities($1) q
  LEFT JOIN prd.cost(q.product_uuid) c
    ON c.product_uuid = q.product_uuid;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
