CREATE OR REPLACE FUNCTION prd.assembly (json, OUT result json) 
LANGUAGE 'plpgsql' AS $$
BEGIN
  WITH parts AS (
    SELECT
      *
    FROM prd.part p
    WHERE p.root_uuid = ($1->>'product_uuid')::uuid
      AND p.parent_uuid = ($1->>'product_uuid')::uuid
  )
  SELECT INTO result
    json_strip_nulls(json_agg(r))
  FROM (
    SELECT
      p.*,
      pv.name AS product_name,
      prd.parts(parent_uuid => p.product_uuid) AS children
    FROM parts p
    LEFT JOIN prd.product_v pv
      USING (product_uuid)
  ) r;
END
$$;
