CREATE OR REPLACE FUNCTION prd.create_assembly (json, OUT result json) AS
$$
DECLARE
  _product_uuid uuid := ($1->>'product_uuid')::uuid;
BEGIN
  WITH new_part AS (
    INSERT INTO prd.part (
      root_uuid,
      part_uuid,
      product_uuid
    ) VALUES (
      _product_uuid,
      _product_uuid,
      _product_uuid
    )
    RETURNING *
  )
  SELECT INTO result
    json_strip_nulls(to_json(r))
  FROM (
    SELECT
      n.*
    FROM new_part n 
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
