CREATE OR REPLACE FUNCTION prd.create_attribute (json, OUT result json) AS
$$
BEGIN
  WITH new_attribute AS (
    INSERT INTO prd.product_attribute (
      product_uuid,
      name,
      value
    )
    SELECT
      p.product_uuid,
      p.name,
      p.value
    FROM json_to_record($1) AS p (
      product_uuid uuid,
      name         text,
      value        text
    )
    RETURNING *
  )
  SELECT to_json(r) INTO result
  FROM (
    SELECT
      a.attribute_uuid,
      a.name,
      a.value
    FROM new_attribute a
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
