CREATE OR REPLACE FUNCTION prd.create_part (json, OUT result json) AS
$$
DECLARE
  new_part_uuid uuid;
BEGIN
  WITH new_part AS (
    INSERT INTO prd.part (
      root_uuid,
      parent_uuid,
      product_uuid,
      name,
      quantity
    )
    SELECT
      p.*
    FROM json_to_record($1) AS p (
      root_uuid    uuid,
      parent_uuid  uuid,
      product_uuid uuid,
      name         text,
      quantity     numeric(10,3)
    )
    RETURNING *
  )
  SELECT INTO result
    json_strip_nulls(to_json(r))
  FROM (
    SELECT
      n.*,
      p.name AS product_name
    FROM new_part n
    LEFT JOIN prd.product_v p
      USING (product_uuid)
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
