CREATE OR REPLACE FUNCTION prd.product (uuid, OUT result prd.product_v) AS
$$
BEGIN
  SELECT INTO result
    p.*
  FROM prd.product_v p
  WHERE p.product_uuid = $1
    AND (p.end_at IS NULL OR p.end_at > CURRENT_TIMESTAMP);
END
$$
LANGUAGE 'plpgsql';

CREATE OR REPLACE FUNCTION prd.product (json DEFAULT NULL, product uuid DEFAULT NULL, OUT result json) AS
$$
BEGIN
  SELECT INTO result
    json_strip_nulls(to_json(p))
  FROM prd.product(COALESCE($2, ($1->>'product_uuid')::uuid)) p;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
