CREATE OR REPLACE FUNCTION prj.create_job (json, OUT result json) AS
$$
BEGIN
  WITH payload AS (
    SELECT
      name,
      dependant_uuid
    FROM json_to_record($1) AS p (
      dependant_uuid uuid,
      name           text
    )
  ),
  job AS (
    INSERT INTO prj.job (
      dependant_uuid,
      name
    )
    SELECT
      p.dependant_uuid,
      p.name
    FROM payload p
    RETURNING *
  )
  SELECT
    to_json(r)
  INTO
    result
  FROM (
    SELECT
      *
    FROM job j
  ) r;
END
$$
LANGUAGE 'plpgsql';
