CREATE OR REPLACE FUNCTION prj.create_project (json, OUT result json) AS
$$
BEGIN
  WITH payload AS (
    SELECT
      p.owner_uuid,
      p.name,
      p.template,
      p.user_uuid AS created_by
    FROM json_to_record($1) AS p (
      owner_uuid uuid,
      user_uuid  uuid,
      name       text,
      template   boolean
    )
  ), project AS (
    INSERT INTO prj.project (
      owner_uuid,
      name
    )
    SELECT
      p.owner_uuid,
      p.name
    FROM payload p
    RETURNING *
  )
  SELECT to_json(r) INTO result
  FROM (
    SELECT
      p.project_uuid,
      p.name
    FROM project p
  ) r;
END
$$
LANGUAGE 'plpgsql';
