/**
Return the deliverables for the given job_uuid
*/
CREATE OR REPLACE FUNCTION prj.deliverables (json DEFAULT NULL, job_uuid uuid DEFAULT NULL, OUT result json) AS
$$
BEGIN
  SELECT json_strip_nulls(json_agg(r)) INTO result
  FROM (
    SELECT
      d.deliverable_uuid,
      i.item_uuid,
      i.name,
      d.sequence_num
    FROM prj.deliverable d
    LEFT JOIN scm.item i
      ON i.item_uuid = d.item_uuid
    WHERE d.job_uuid = ($1->>'job_uuid')::uuid
      OR d.job_uuid = deliverables.job_uuid
    ORDER BY d.sequence_num
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
