CREATE OR REPLACE FUNCTION prj.flatten_job (uuid) RETURNS SETOF prj.job AS
$$
BEGIN
  RETURN QUERY
  WITH RECURSIVE jobs AS (
    -- Select the top level job
    SELECT
      j.job_uuid,
      j.dependant_uuid,
      0 AS level
    FROM prj.job j
    WHERE j.job_uuid = $1

    UNION ALL

    SELECT
      j.job_uuid,
      j.dependant_uuid,
      jobs.level + 1 AS level
    FROM jobs
    INNER JOIN prj.job j
      ON j.dependant_uuid = jobs.job_uuid
  )
  SELECT
    j.*
  FROM jobs
  LEFT JOIN prj.job j
    USING (job_uuid)
  ORDER BY jobs.level, j.sequence_num;
END
$$
LANGUAGE 'plpgsql';
