CREATE OR REPLACE FUNCTION prj.jobs (json, OUT result json) AS
$$
BEGIN
  SELECT json_strip_nulls(json_agg(r)) INTO result
  FROM (
    SELECT
      j.job_uuid,
      j.name,
      j.short_desc,
      j.sequence_num
    FROM prj.job j
    WHERE j.dependant_uuid = ($1->>'job_uuid')::uuid
    ORDER BY j.sequence_num
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
