/*
List projects based on a user's relationship to the projects.

Return projects for owners and creators.
*/

CREATE OR REPLACE FUNCTION prj.list_projects (json DEFAULT NULL, OUT result json) AS
$$
BEGIN
  SELECT json_strip_nulls(json_agg(r)) INTO result
  FROM (
    SELECT
      p.project_uuid,
      p.name
    FROM prj.project p
    INNER JOIN (
      SELECT
        *
      FROM prj.project_role pr
      WHERE pr.party_uuid = ($1->>'user_uuid')::uuid
    ) u
      ON u.project_uuid = p.project_uuid
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
