CREATE OR REPLACE FUNCTION prj.project (json, OUT result json) AS
$$
BEGIN
  SELECT json_strip_nulls(to_json(r)) INTO result
  FROM (
    SELECT
      p.project_uuid,
      j.job_uuid,
      p.owner_uuid,
      p.address_uuid,
      owner.name AS "ownerName",
      p.name,
      j.dependant_uuid,
      j.name,
      j.short_desc,
      j.description,
      j.created_by,
      j.created
    FROM prj.project p
    LEFT JOIN prj.project_job pj
      USING (project_uuid)
    LEFT JOIN prj.job j
      USING (job_uuid)
    LEFT JOIN core.party owner
      ON owner.party_uuid = p.owner_uuid
    WHERE p.project_uuid = ($1->>'project_uuid')::uuid
  ) r;
END
$$
LANGUAGE 'plpgsql';
