CREATE OR REPLACE FUNCTION sales.price (uuid, OUT result sales.product_price_v) AS
$$
BEGIN
  WITH price AS (
    SELECT DISTINCT ON (p.product_uuid)
      p.*
    FROM sales.product_price_v p
    WHERE p.product_uuid = $1
    ORDER BY p.product_uuid, p.created DESC
  )
  SELECT INTO result
    p.*
  FROM price p;
END
$$
LANGUAGE 'plpgsql';

CREATE OR REPLACE FUNCTION sales.price (json, OUT result json) AS
$$
BEGIN
  SELECT INTO result
    json_strip_nulls(to_json(p))
  FROM sales.price(($1->>'product_uuid')::uuid) p;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
