CREATE OR REPLACE FUNCTION sales.quote (
  quote_uuid uuid DEFAULT NULL,
  order_uuid uuid DEFAULT NULL
) RETURNS SETOF sales.quote_v LANGUAGE 'plpgsql' AS
$$
BEGIN
  RETURN QUERY
  SELECT
    q.*
  FROM sales.quote_v q
  WHERE q.quote_uuid = $1 OR q.order_uuid = $2;
END
$$;

CREATE OR REPLACE FUNCTION sales.quote (json, OUT result json) AS
$$
BEGIN
  SELECT INTO result
    CASE
      WHEN $1->'quote_uuid' IS NOT NULL THEN
        json_strip_nulls(to_json(q))
      ELSE
        json_strip_nulls(json_agg(q))
    END
  FROM sales.quote(
    ($1->>'quote_uuid')::uuid,
    ($1->>'order_uuid')::uuid
  ) q
  GROUP BY q.*;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
