CREATE OR REPLACE FUNCTION scm.create_item_attribute (json, OUT result json) AS
$$
BEGIN
  WITH new_attribute AS (
    INSERT INTO scm.attribute (
      item_uuid,
      name,
      value
    )
    SELECT
      p.item_uuid,
      p.name,
      p.value
    FROM json_to_record($1) AS p (
      item_uuid uuid,
      name      text,
      value     text
    )
    RETURNING *
  )
  SELECT json_strip_nulls(to_json(r)) INTO result
  FROM (
    SELECT
      a.attribute_uuid,
      a.name,
      a.value
    FROM new_attribute a
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
