CREATE OR REPLACE FUNCTION scm.create_part (json, OUT result json) AS
$$
DECLARE
  new_item_uuid uuid;
BEGIN
  WITH payload AS (
    SELECT
      p.product_uuid,
      p.name
    FROM json_to_record($1) AS p (
      product_uuid    uuid,
      name            text
    )
  ),
  new_item AS (
    INSERT INTO scm.item (
      product_uuid,
      name
    )
    SELECT
      product_uuid,
      name
    FROM payload
    RETURNING *
  ),
  new_part AS (
    INSERT INTO scm.part (
      parent_uuid,
      item_uuid
    ) VALUES (
      ($1->>'item_uuid')::uuid,
      (SELECT item_uuid FROM new_item)
    )
  )
  SELECT INTO result
    json_strip_nulls(to_json(r))
  FROM (
    SELECT
      $1->>'name' AS name,
      (SELECT item_uuid FROM new_item)
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
