CREATE OR REPLACE FUNCTION scm.create_route (json, OUT result json) AS
$$
DECLARE
  new_route_uuid uuid;
BEGIN
  WITH new_route AS (
    INSERT INTO scm.route (
      name
    ) VALUES (
      $1->>'name'
    )
    RETURNING *
  )
  INSERT INTO scm.product_route (
    product_uuid,
    route_uuid
  ) VALUES (
    ($1->>'product_uuid')::uuid,
    (SELECT route_uuid FROM new_route)
  )
  RETURNING route_uuid INTO new_route_uuid;

  result = scm.route(route_uuid => new_route_uuid);
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
