CREATE OR REPLACE FUNCTION scm.create_task (json, OUT result json) AS
$$
DECLARE
  new_task_uuid uuid;
BEGIN
  WITH payload AS (
    SELECT
      p.*
    FROM json_to_record($1) AS p (
      route_uuid   uuid,
      product_uuid uuid,
      name         text
    )
  )
  INSERT INTO scm.task (
    product_uuid,
    route_uuid,
    name
  )
  SELECT
    p.product_uuid,
    p.route_uuid,
    p.name
  FROM payload p
  RETURNING task_uuid INTO new_task_uuid;
  
  result = scm.task(task_uuid => new_task_uuid);
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
