/**
Insert all the tasks from an item's route into the item task queue
*/
CREATE OR REPLACE FUNCTION scm.enqueue_item (
  uuid,
  batch_uuid uuid
) RETURNS SETOF scm.task_item AS
$$
BEGIN
  RETURN QUERY
  WITH items AS (
    INSERT INTO scm.task_item (
      task_uuid,
      item_uuid,
      batch_uuid
    )
    SELECT
      t.task_uuid,
      fi.item_uuid,
      enqueue_item.batch_uuid
    FROM scm.flatten_item($1) fi
    LEFT JOIN scm.item i
      ON i.item_uuid = fi.item_uuid
    INNER JOIN scm.route r
      ON r.product_uuid = i.product_uuid
    LEFT JOIN scm.task t
      ON t.route_uuid = r.route_uuid
    ORDER BY fi.level DESC, t.sequence_num
    ON CONFLICT DO NOTHING
    RETURNING *
  )
  SELECT * FROM items;
END
$$
LANGUAGE 'plpgsql';
