CREATE OR REPLACE FUNCTION scm.finish_task (json, OUT result json) AS
$$
BEGIN
  UPDATE scm.task_item ti
  SET finished_at = CURRENT_TIMESTAMP
  WHERE ti.item_uuid = ($1->>'item_uuid')::uuid
    AND ti.task_uuid = ($1->>'task_uuid')::uuid;

  SELECT json_strip_nulls(to_json(r)) INTO result
  FROM (
    SELECT
      ($1->>'item_uuid')::uuid AS item_uuid,
      ($1->>'task_uuid')::uuid AS task_uuid,
      CURRENT_TIMESTAMP AS finished_at
  ) r;
END
$$
LANGUAGE 'plpgsql';
