CREATE OR REPLACE FUNCTION scm.flatten_item (uuid)
RETURNS TABLE (
  root_uuid    uuid,
  item_uuid    uuid,
  parent_uuid  uuid,
  level        integer
) AS
$$
BEGIN
  RETURN QUERY
  WITH RECURSIVE item AS (
    SELECT
      i.item_uuid,
      NULL::uuid AS parent_uuid,
      0 AS level
    FROM scm.item i
    WHERE i.item_uuid = $1

    UNION ALL

    SELECT
      p.item_uuid,
      i.item_uuid AS parent_uuid,
      i.level + 1 AS level
    FROM item i
    INNER JOIN scm.part p
      ON p.parent_uuid = i.item_uuid
  )
  SELECT
    $1 AS root_uuid,
    i.*
  FROM item i;
END
$$
LANGUAGE 'plpgsql';
