CREATE OR REPLACE FUNCTION scm.item_boq (uuid)
RETURNS TABLE (
  item_uuid    uuid,
  product_uuid uuid,
  quantity     numeric(10,3)
) AS
$$
BEGIN
  RETURN QUERY
  WITH item AS (
    SELECT
      i.*
    FROM scm.flatten_item($1) i
  )
  SELECT
    $1 AS item_uuid,
    c.product_uuid,
    sum(c.quantity)
  FROM item i
  INNER JOIN scm.component c
    USING (item_uuid)
  LEFT JOIN prd.product_v pv
    ON pv.product_uuid = c.product_uuid
  GROUP BY c.product_uuid;
END
$$
LANGUAGE 'plpgsql';
