CREATE OR REPLACE FUNCTION scm.item(uuid, OUT result scm.item_t) AS
$$
BEGIN
  SELECT
    i.item_uuid,
    i.product_uuid,
    i.name,
    i.short_desc,
    i.data,
    pv.code,
    pv.name,
    pv.short_desc,
    i.created
  INTO
    result.item_uuid,
    result.product_uuid,
    result.name,
    result.short_desc,
    result.data,
    result.product_code,
    result.product_name,
    result.product_short_desc,
    result.created
  FROM scm.item i
  LEFT JOIN prd.product_v pv
    USING (product_uuid)
  WHERE i.item_uuid = $1;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;

CREATE OR REPLACE FUNCTION scm.item (json, OUT result json) 
LANGUAGE 'plpgsql' AS $$
BEGIN
  SELECT INTO result
    json_strip_nulls(to_json(i))
  FROM scm.item(($1->>'item_uuid')::uuid) i;
END
$$;
