/*
Return a list of all Routes in alphabetical order
*/

CREATE OR REPLACE FUNCTION scm.list_routes (json DEFAULT NULL, OUT result json) AS
$$
BEGIN
  SELECT json_strip_nulls(json_agg(r)) INTO result
  FROM (
    SELECT
      r.route_uuid,
      r.name
    FROM scm.route r
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
