CREATE OR REPLACE FUNCTION scm.list_tasks (
  json DEFAULT NULL,
  task_uuid uuid DEFAULT NULL,
  OUT result json
) AS
$$
BEGIN
  SELECT json_strip_nulls(json_agg(r)) INTO result
  FROM (
    SELECT
      t.task_uuid,
      t.name,
      p.name AS product_name
    FROM scm.task t
    LEFT JOIN prd.product p
      USING (product_uuid)
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
