CREATE OR REPLACE FUNCTION scm.route (json DEFAULT NULL, route_uuid uuid DEFAULT NULL, OUT result json) AS
$$
BEGIN
  SELECT json_strip_nulls(to_json(r)) INTO result
  FROM (
    SELECT
      r.route_uuid,
      r.name
    FROM scm.route r
    WHERE r.route_uuid = ($1->>'route_uuid')::uuid
      OR r.route_uuid = $2
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
