CREATE OR REPLACE FUNCTION scm.task (json DEFAULT NULL, task_uuid uuid DEFAULT NULL, OUT result json) AS
$$
BEGIN
  SELECT json_strip_nulls(to_json(r)) INTO result
  FROM (
    SELECT
      t.task_uuid,
      t.name,
      t.product_uuid,
      p.name AS "productName",
      p.code AS "productCode"
    FROM scm.task t
    LEFT JOIN prd.product_v p
      USING (product_uuid)
    WHERE t.task_uuid = ($1->>'task_uuid')::uuid
      OR t.task_uuid = $2
  ) r;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
