CREATE OR REPLACE FUNCTION scm.tasks (json, OUT result json) AS
$$
BEGIN
  IF $1->'route_uuid' IS NOT NULL THEN
    SELECT INTO result
      json_strip_nulls(json_agg(r))
    FROM (
      SELECT
        t.task_uuid,
        t.name,
        COALESCE(t.name, p.name) AS name,
        t.sequence_num
      FROM scm.task t
      LEFT JOIN prd.product_v p
        USING (product_uuid)
      WHERE t.route_uuid = ($1->>'route_uuid')::uuid
      ORDER BY t.sequence_num
    ) r;
  ELSIF $1->'item_uuid' IS NOT NULL THEN
    SELECT INTO result
      json_strip_nulls(json_agg(r))
    FROM (
      SELECT
        ti.task_uuid,
        ti.item_uuid,
        ti.finished_at,
        t.name,
        p.name AS product_name
      FROM scm.task_item ti
      LEFT JOIN scm.task t
        ON t.task_uuid = ti.task_uuid
      LEFT JOIN prd.product_v p
        ON p.product_uuid = t.product_uuid
      WHERE ti.item_uuid = ($1->>'item_uuid')::uuid
      ORDER BY t.sequence_num
    ) r;
  END IF;
  
END
$$
LANGUAGE 'plpgsql';
