/*
Create a dyamic query that only updates fileds that present on the payload
*/
CREATE OR REPLACE FUNCTION scm.update_attribute (json, OUT result json) AS
$$
BEGIN
  EXECUTE (
    SELECT
      format('UPDATE scm.attribute SET (%s) = (%s) WHERE attribute_uuid = ''%s''', c.column, c.value, c.attribute_uuid)
    FROM (
      SELECT
        string_agg(q.column, ', ') AS column,
        string_agg(q.value, ', ') AS value,
        ($1->>'attribute_uuid')::uuid AS attribute_uuid
      FROM (
        SELECT
          p.key AS column,
          CASE
            WHEN p.value IS NULL THEN
              'NULL'
            ELSE quote_literal(p.value)
          END AS value
        FROM json_each_text($1) p
        WHERE p.key != 'attribute_uuid'
      ) q
    ) c
  );

  SELECT INTO result
    json_strip_nulls(to_json(a))
  FROM scm.attribute a
  WHERE a.attribute_uuid = ($1->>'attribute_uuid')::uuid;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
