/*
Create a dyamic query that only updates fileds that present on the payload
*/
CREATE OR REPLACE FUNCTION scm.update_component (json, OUT result json) AS
$$
BEGIN
  EXECUTE (
    SELECT
      format('UPDATE scm.component SET (%s) = (%s) WHERE component_uuid =''%s''', c.column, c.value, c.component_uuid)
    FROM (
      SELECT
        string_agg(q.column, ', ') AS column,
        string_agg(q.value, ', ') AS value,
        ($1->>'component_uuid')::uuid AS component_uuid
      FROM (
        SELECT
          p.key AS column,
          CASE
            -- check if it's a number
            WHEN p.value ~ '^\d+(.\d+)?$' THEN
              p.value
            WHEN p.value IS NULL THEN
              'NULL'
            ELSE quote_literal(p.value)
          END AS value
        FROM json_each_text($1) p
        WHERE p.key != 'component_uuid' AND p.key != 'user_uuid'
      ) q
    ) c
  );

  SELECT INTO result
    json_strip_nulls(to_json(c))
  FROM scm.component c
  WHERE c.component_uuid = ($1->>'component_uuid')::uuid;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
