CREATE OR REPLACE FUNCTION public.update (schema_name name, table_name name, payload json) RETURNS VOID AS
$$
BEGIN
  EXECUTE (
    SELECT
      format('UPDATE %s.%s SET (%s) = (%s) WHERE purchase_order_uuid = ''%s''', $1, $2, c.column, c.value, c.purchase_order_uuid)
    FROM (
      SELECT
        string_agg(q.column, ', ') AS column,
        string_agg(q.value, ', ') AS value,
        ($1->>'purchase_order_uuid')::uuid AS purchase_order_uuid
      FROM (
        SELECT
          p.key AS column,
          CASE
            -- check if it's a number
            WHEN p.value ~ '^\d+(.\d+)?$' THEN
              p.value
            WHEN p.value IS NULL THEN
              'NULL'
            ELSE quote_literal(p.value)
          END AS value
        FROM json_each_text($1) p
        WHERE p.key != 'purchase_order_uuid'
          AND p.key IN (
            SELECT
              col.column_name
            FROM information_schema.columns col
            WHERE col.table_schema = 'pcm' AND col.table_name = 'purchase_order'
          )
      ) q
    ) c
  );

  SELECT pcm.purchase_order(purchase_order_uuid => ($1->>'purchase_order_uuid')::uuid) INTO result;
END
$$
LANGUAGE 'plpgsql' SECURITY DEFINER;
